// PopupsView.h : interface of the CPopupsView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_POPUPSVIEW_H__8AB76AAC_0215_11D1_85FB_50814CC10000__INCLUDED_)
#define AFX_POPUPSVIEW_H__8AB76AAC_0215_11D1_85FB_50814CC10000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CPopupsView : public CView
{
protected: // create from serialization only
	CPopupsView();
	DECLARE_DYNCREATE(CPopupsView)

// Attributes
public:
	CPopupsDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPopupsView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPopupsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CRect	m_cRect;
	int		m_nQuad;

	void PopupMenu( int nQuad );
	void PopupTips( int nQuad );

// Generated message map functions
protected:
	//{{AFX_MSG(CPopupsView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTestDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in PopupsView.cpp
inline CPopupsDoc* CPopupsView::GetDocument()
   { return (CPopupsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_POPUPSVIEW_H__8AB76AAC_0215_11D1_85FB_50814CC10000__INCLUDED_)
