// KnobCtrl.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL, 
//		run nmake -f KnobCtrlps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"
#include "KnobCtrl.h"

#include "KnobCtrl_i.c"
#include "LevelCtrl.h"
#include "LevelProp.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_LevelCtrl, CLevelCtrl)
	OBJECT_ENTRY(CLSID_LevelProp, CLevelProp)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}



/////////////////////////////////////////////////////////////////////////////
// _LevelEvents properties

/////////////////////////////////////////////////////////////////////////////
// _LevelEvents operations

/*
void _LevelEvents::ClickUp(long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 x, y);
}

void _LevelEvents::ClickDn(long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 x, y);
}
*/


/////////////////////////////////////////////////////////////////////////////
// ILevelCtrl properties

/////////////////////////////////////////////////////////////////////////////
// ILevelCtrl operations

/*
void ILevelCtrl::SetFillColor(unsigned long newValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xfffffe02, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms,
		 newValue);
}

unsigned long ILevelCtrl::GetFillColor()
{
	unsigned long result;
	InvokeHelper(0xfffffe02, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, NULL);
	return result;
}

short ILevelCtrl::GetM_nLevel()
{
	short result;
	InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_I2, (void*)&result, NULL);
	return result;
}

void ILevelCtrl::SetM_nLevel(short nNewValue)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x1, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms,
		 nNewValue);
}
*/

/////////////////////////////////////////////////////////////////////////////
// _LevelEvents properties

/////////////////////////////////////////////////////////////////////////////
// _LevelEvents operations

/*
void _LevelEvents::ClickUp(long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 x, y);
}

void _LevelEvents::ClickDn(long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		 x, y);
}
*/

/////////////////////////////////////////////////////////////////////////////
// ILevelCtrl properties

/////////////////////////////////////////////////////////////////////////////
// ILevelCtrl operations

/*
void ILevelCtrl::SetFillColor(unsigned long newValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xfffffe02, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms,
		 newValue);
}

unsigned long ILevelCtrl::GetFillColor()
{
	unsigned long result;
	InvokeHelper(0xfffffe02, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, NULL);
	return result;
}

short ILevelCtrl::GetM_nLevel()
{
	short result;
	InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_I2, (void*)&result, NULL);
	return result;
}

void ILevelCtrl::SetM_nLevel(short nNewValue)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x1, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms,
		 nNewValue);
}
*/