// Reg_OpsDlg.h : header file
//

#if !defined(AFX_REG_OPSDLG_H__BB276388_2776_11D1_85FB_E5968DB4472D__INCLUDED_)
#define AFX_REG_OPSDLG_H__BB276388_2776_11D1_85FB_E5968DB4472D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CReg_OpsDlg dialog

class CReg_OpsDlg : public CDialog
{
// Construction
public:
	CReg_OpsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CReg_OpsDlg)
	enum { IDD = IDD_REG_OPS_DIALOG };
	CComboBox	m_cbNamesList;
	CString		m_csNameEntry;
	DWORD		m_dwNameStatus;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReg_OpsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
protected:
	BOOL InitializeListBox();
	BOOL AddToRegistry();
	void ResetButtons();
	void GetButtonStatus();
	BOOL GetPassword();
	void EnableButtons( BOOL );
	void ReportError( long );
	BOOL ConfirmPassword();
	void PermitUpdate();

// Implementation
protected:
	HICON	m_hIcon;
	HKEY	m_hRegKey;
	CString	m_csPassword;
	BOOL	m_bUpdate;

	// Generated message map functions
	//{{AFX_MSG(CReg_OpsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStatus2();
	afx_msg void OnStatus3();
	afx_msg void OnStatus4();
	afx_msg void OnStatus5();
	afx_msg void OnExit();
	afx_msg void OnEditchangeNamesList();
	afx_msg void OnAddEntry();
	afx_msg void OnCloseupNamesList();
	afx_msg void OnStatus1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REG_OPSDLG_H__BB276388_2776_11D1_85FB_E5968DB4472D__INCLUDED_)
