// BrowserDlg.h : header file
//

#if !defined(AFX_BROWSERDLG_H__3F779246_2BB9_11D1_85FB_BABE6CE65921__INCLUDED_)
#define AFX_BROWSERDLG_H__3F779246_2BB9_11D1_85FB_BABE6CE65921__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CBrowserDlg dialog

class CBrowserDlg : public CDialog
{
// Construction
public:
	CBrowserDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBrowserDlg)
	enum { IDD = IDD_BROWSER_DIALOG };
	CString	m_csEdit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBrowserDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	HANDLE	m_hMapFile;		// file-mapping object
	char  * m_pView;		// base address of a mapped file view
	int		m_nSection;

	void	ShowErrorMsg( int iLine );
	void	OnChangeAccess( int iNewAccess );
	// Generated message map functions
	//{{AFX_MSG(CBrowserDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClear();
	afx_msg void OnRead();
	afx_msg void OnWrite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BROWSERDLG_H__3F779246_2BB9_11D1_85FB_BABE6CE65921__INCLUDED_)
