        .model  medium
;***********************************************************************
;                              OLDKEY.ASM
;    OLDKEY [DECLARE SUB OLDKEY()] allows KBPEEK to operate correctly on
; certain old "compatibles" with 83-key keyboards that send a false 
; "101-key keyboard installed" signal.
;                Copyright (C) 1991 by Murray L. Lesser
;***********************************************************************
extrn   B_OnExit: far
.code

oldint  dd      0               ;Old INT 16h vector, in code space
newint  proc                    ;New INT 16 handler, not a public PROC
        and     ah,0fh
        jmp     cs:oldint
newint  endp

        public  oldkey
oldkey  proc
        push    bp
        push    ds
        mov     ax,3516h        ;Get original INT 16H vector
        int     21h
        mov     word ptr oldint,bx      ;  and save it for return
        mov     word ptr oldint+2,es
        push    cs                      ;Far address of FIXIT (the
        mov     ax,offset fixit         ;   vector-restore routine)
        push    ax
        call    B_OnExit                ;FIXIT will be run at END
        mov     ax,2516h        ;Load newhandler vector for INT 16h
        push    cs
        pop     ds
        mov     dx,offset newint
        int     21h
        pop     ds
        pop     bp
        ret
oldkey  endp

fixit   proc                    ;Not a public PROC
        push    bp
        push    ds
        push    dx
        lds     dx,cs:oldint
        mov     ax,2516h
        int     21h
        pop     dx
        pop     ds
        pop     bp
        ret
fixit   endp
        end
