      include 'winapi.for'
$nolist
      include 'flib.fi'
$list
$page
      PROGRAM WINDOWS_GRAPHICS
      real*4 TWOPI/6.283185308/,HALFSR2/0.707106781/
      real*4 rr,r,rred,rgrn,rblu
      real*4 u1,u2,w,x,y
      integer*4 MoveTo, SetPixel, xyprev
      integer*2 GetFocus, GetDC, ReleaseDC
      integer*2 Rectangle, Ellipse, LineTo
      integer*2 CreatePen, SelectObject, SetTextColor, TextOut
      integer*2 hwnd, hdc
      logical*2 DeleteObject, ldum
      integer*4 lrgb, il, nl
      integer*1 brgb(4)
      equivalence (brgb,lrgb)           ! Map 4 bytes into one I*4
      character line*80
c
$nolist
      include 'flib.fd'
$list
c
      structure /s_rect/
        integer*2 left, top, right, bottom
      endstructure
      record /s_rect/ clisize
c
      ids = aboutboxqq('MSF Win Demo'//char(13)//
     &  'Kenneth G. Hamilton'//char(0))
c
      print 20
   20 format (
     & ' Maximize this window now in order to see the full show'/
     & ' Enter the number of lines to draw (10,000 is good)->',$)
      read (*,*) nl
c
      hwnd = GetFocus()                 ! Note, no arguments needed
      call GetClientRect(hwnd,clisize)  ! Get size of client area
      print 100, clisize.left, clisize.right,
      &          clisize.top,  clisize.bottom
  100 format (' Client Size in Pixels: Left:',I4,', Right :',I4/
     &                            24X,'Top :',I4,', Bottom:',I4)
      hdc = GetDC(hwnd)                 ! Using previous result
      if (hdc.eq.0) stop 'Bad hDC in Graphics Setup'
c
      istat = TextOut(hdc,450,10,'Hello',5)
      istat = SetTextColor(hdc,#000000FF)       ! Red
      istat = TextOut(hdc,450,40,'Red',3)
      istat = SetTextColor(hdc,#0000FF00)       ! Green
      istat = TextOut(hdc,450,70,'Green',5)
      istat = SetTextColor(hdc,#00FF0000)       ! Blue
      istat = TextOut(hdc,450,100,'Blue',4)
      istat = SetTextColor(hdc,#0000FFFF)       ! Yellow
      istat = TextOut(hdc,450,130,'Yellow',6)
      istat = SetTextColor(hdc,#00FF00FF)       ! Magenta
      istat = TextOut(hdc,450,160,'Magenta',7)
      istat = SetTextColor(hdc,#00FFFF00)       ! Cyan
      istat = TextOut(hdc,450,190,'Cyan',4)
      istat = SetTextColor(hdc,#00000000)       ! Black
      line = 'This was done exclusively with Microsoft Fortran 5.10'
      lenline = len_trim(line)
      istat = TextOut(hdc,150,340,line,lenline)
c     Draw a few geometric figures
      istat = Rectangle(hdc,50,300,150,320)
      istat = Ellipse(hdc,50,50,150,250)
c     Make a Gaussian cloud in the middle of the ellipse by
c     marking pixels with green dots
      do i=1,30000
        call random(u1)
        call random(u2)
        u1 = 2*u1 - 1
        u2 = 2*u2 - 1
        w = u1**2 + u2**2
        if (w.gt.1.) cycle
        w = sqrt(-2*alog(w)/w)
        x = u1*w
        y = u2*w
        ix = 100+nint(25*x)
        iy = 150+nint(25*y)
        lrgb = SetPixel(hdc,ix,iy,#0000FF00)
      enddo
c     Draw the logo for this project
c
      ipen  = CreatePen(0,8,#00000000)  ! Make a wide black pen
      istat = SelectObject(hdc,ipen)    ! Use it
      ix0=500                           ! Center of emblem
      iy0=270
      do iazim=135,360+45,5             ! 3/4 of a circle
        ix = nint(float(ix0) + 20.*sin(TWOPI*float(iazim)/360.))
        iy = nint(float(iy0) + 20.*cos(TWOPI*float(iazim)/360.))
        if (iazim.eq.135) then
          xyprev = MoveTo(hdc,ix,iy)    ! First point
        else
          istat = LineTo(hdc,ix,iy)     ! subsequent ones
        endif
      enddo
c
      ipenold = ipen                    ! Save old pen
      ipen  = CreatePen(0,8,#000000FF)  ! Make a wide red pen
      istat = SelectObject(hdc,ipen)    ! Use it
      ldum  = DeleteObject(ipenold)     ! Wipe out old pen
      do iazim=0,360,5                  ! Full circle
        ix = nint(float(ix0) + 30.*sin(TWOPI*float(iazim)/360.))
        iy = nint(float(iy0) + 30.*cos(TWOPI*float(iazim)/360.))
        if (iazim.eq.0) then
          xyprev = MoveTo(hdc,ix,iy)    ! First point
        else
          istat = LineTo(hdc,ix,iy)     ! All the others
        endif
      enddo
c
      ix = nint(float(ix0) + 30.*HALFSR2)  ! Diagonal slash
      iy = nint(float(iy0) - 30.*HALFSR2)
      xyprev = MoveTo(hdc,ix,iy)        ! Move without drawing
      ix = nint(float(ix0) - 30.*HALFSR2)
      iy = nint(float(iy0) + 30.*HALFSR2)
      istat = LineTo(hdc,ix,iy)
c     Color Ball
c
      ix0=320
      iy0=180
      rr=120.
      ipenold = ipen
      ipen = CreatePen(0,1,#00000000)   ! Make a narrow black pen
      istat = SelectObject(hdc,ipen)    ! Use it
      ldum  = DeleteObject(ipenold)     ! Wipe out old wide pen
      xyprev = MoveTo(hdc,ix0,iy0)      ! Go to center of circle
      do il=1,nl
        if (mod(il,100).eq.0) then      ! If 100th line,
          call random(rred)             ! random amount of red
          call random(rgrn)             ! random amount of green
          call random(rblu)             ! random amount of blue
          brgb(1)=int1(255.*rred)       ! Pack colors into I*4 hue
          brgb(2)=int1(255.*rgrn)       ! Easier than using ISHFT
          brgb(3)=int1(255.*rblu)
          brgb(4)=0                     ! Top byte is always zero
          ipenold=ipen                  ! This is the previous pen
          ipen  = CreatePen(0,1,lrgb)   ! Make pen of the new color
          istat = SelectObject(hdc,ipen)! Use it
          ldum  = DeleteObject(ipenold) ! Wipe out old pen
        endif
        call random(r)                  ! Make a random position
        ix=ix0+nint(rr*cos(TWOPI*r))    ! on the edge of the
        iy=iy0+nint(rr*sin(TWOPI*r))    ! circle, and then
        istat = LineTo(hdc,ix,iy)       ! draw a line to it.
      enddo
c
      is = ReleaseDC(hwnd,hdc)          ! Give back what we took
c
      stop
      end
