// wincovw.h : interface of the CWincolorView class
//
/////////////////////////////////////////////////////////////////////////////

class CWincolorView : public CFormView
{
protected: // create from serialization only
	CWincolorView();
	DECLARE_DYNCREATE(CWincolorView)

public:
	//{{AFX_DATA(CWincolorView)
	enum { IDD = IDD_WINCOLOR_FORM };
	CScrollBar	m_ScrollAverage;
	CScrollBar	m_ScrollGreen;
	CScrollBar	m_ScrollBlue;
	CScrollBar	m_ScrollRed;
	CString	m_EditRed;
	CString	m_EditBlue;
	CString	m_EditGreen;
	//}}AFX_DATA

// Attributes
public:
	CWincolorDoc* GetDocument();
   HBRUSH	m_hRedBrush, m_hBlueBrush, m_hGreenBrush,
   			m_hCompBrush,
   			m_hAverageBrush; 
   
// Operations
public:

// Implementation
public:
	virtual ~CWincolorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	
// Generated message map functions
protected:  
	virtual void OnInitialUpdate();	
	//{{AFX_MSG(CWincolorView)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnReset();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in wincovw.cpp
inline CWincolorDoc* CWincolorView::GetDocument()
   { return (CWincolorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
