// bmpdoc.h : interface of the CBmpDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CBmpDoc : public CDocument
{
protected: // create from serialization only
	CBmpDoc();
	DECLARE_DYNCREATE(CBmpDoc)

// Attributes
public:    
    HBITMAP m_hBitmap;
    HPALETTE m_hPal;

// Operations
public:
    void DeleteContents( );                            //deletes document contents         

// Implementation
public:
	virtual ~CBmpDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnOpenDocument(const char *pszPathName);

// Generated message map functions
protected:
	//{{AFX_MSG(CBmpDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
