// testsdoc.cpp : implementation of the CTestsdiDoc class
//

#include "stdafx.h"
#include "testsdi.h"
#include "testsdoc.h"

#include "tv1.h"
#include "tv2.h"
#include "tv3.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestsdiDoc

IMPLEMENT_DYNCREATE(CTestsdiDoc, CDocument)

BEGIN_MESSAGE_MAP(CTestsdiDoc, CDocument)
    //{{AFX_MSG_MAP(CTestsdiDoc)
    ON_COMMAND(IDD_TESTVIEW_FORM1, OnTestviewForm1)
    ON_COMMAND(IDD_TESTVIEW_FORM2, OnTestviewForm2)
    ON_COMMAND(IDD_TESTVIEW_FORM3, OnTestviewForm3)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestsdiDoc construction/destruction

CTestsdiDoc::CTestsdiDoc()
{
    v1 = v2 = v3 = NULL ;
}

CTestsdiDoc::~CTestsdiDoc()
{
}

BOOL CTestsdiDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

    v1 = v2 = v3 = NULL ;

    POSITION fp = GetFirstViewPosition() ;
    v1 = GetNextView(fp) ;

    CSDIMultiViewWnd *mvf = (CSDIMultiViewWnd *)(v1->GetParentFrame()) ;

    if (v2 == NULL) {

        CCreateContext context;
        context.m_pCurrentFrame = NULL ;
        context.m_pCurrentDoc = this;
        context.m_pNewViewClass = RUNTIME_CLASS(CTestviewView2) ;
        context.m_pNewDocTemplate = GetDocTemplate();

        v2 = (CView *)(mvf->AddView(&context)) ;

    }

    if (v3 == NULL) {

        CCreateContext context;
        context.m_pCurrentFrame = NULL ;
        context.m_pCurrentDoc = this;
        context.m_pNewViewClass =
                        RUNTIME_CLASS(CTestviewView3) ;
        context.m_pNewDocTemplate = GetDocTemplate();

        v3 = (CView *)(mvf->AddView(&context)) ;

    }

    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CTestsdiDoc serialization

void CTestsdiDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
    }
    else
    {
        // TODO: add loading code here
    }
}

/////////////////////////////////////////////////////////////////////////////
// CTestsdiDoc diagnostics

#ifdef _DEBUG
void CTestsdiDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CTestsdiDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestsdiDoc commands

void CTestsdiDoc::OnTestviewForm1()
{
    // GetParentFrame is not virtual,
    //so we must cast to CMulitViewWnd
    CSDIMultiViewWnd *pf =
            (CSDIMultiViewWnd *)
                    (v1->GetParentFrame()) ;

    pf->SetActiveView(v1) ;
    
}

void CTestsdiDoc::OnTestviewForm2()
{
    // GetParentFrame is not virtual,
    //so we must cast to CMulitViewWnd
    CSDIMultiViewWnd *pf =
            (CSDIMultiViewWnd *)
                    (v2->GetParentFrame()) ;

    pf->SetActiveView(v2) ;
    
}

void CTestsdiDoc::OnTestviewForm3()
{
    // GetParentFrame is not virtual,
    //so we must cast to CMulitViewWnd
    CSDIMultiViewWnd *pf =
            (CSDIMultiViewWnd *)
                    (v3->GetParentFrame()) ;

    pf->SetActiveView(v3) ;
    
}

