// fiber.h

#define NUM_CARS_PER_TYPE 3
#define NUM_CAR_TYPES     2
#define NUM_ITEMS         (NUM_CAR_TYPES * NUM_CARS_PER_TYPE)
#define NUM_TURNS         10

#define SPORTS_SPEED      75
#define SPORTS_GPH        5
#define ECONOMY_SPEED     55
#define ECONOMY_GPH       1
#define FUEL_COST         140   // $1.40 per gallon

typedef struct {
    LPVOID pMainFiber;
    LPVOID pItemFiber[NUM_ITEMS];
} TURN_SCHEDULER_DATA, *LPTURN_SCHEDULER_DATA;

typedef struct {
    LPVOID pTurnScheduler;
    DWORD  CarID;
    DWORD  Distance;
    DWORD  Cost;
} CAR_FIBER_DATA, *LPCAR_FIBER_DATA;

VOID WINAPI TurnSchedulerFiber(LPTURN_SCHEDULER_DATA);
VOID WINAPI SportsCarFiber(LPCAR_FIBER_DATA);
VOID WINAPI EconomyCarFiber(LPCAR_FIBER_DATA);

