//
// This program demonstrates a code generation bug
// in Visual C++ 4.1.  The program calculates
// the arc tangent of 1, which should be 45 degrees.
// Compiling this console mode program with /Od as an
// option gives the correct result for theta.
// Compiling with /Ox causes the program to calculate
// theta as something in the neighborhood of 54 degrees.
//

#include <iostream.h>
#include <math.h>

double theta;

void Calc( int &x, int &y )
{
        double alpha = x - 5;
        double beta  = y - 7;
        double A = sqrt( ( alpha * alpha ) + ( beta * beta ) );
        theta = atan2( beta, alpha );

        double phi = atan2( 5.0, 3.0 );

        x = A * cos( theta );
        y = A * sin( theta );
}

main()
{
        int x = 6;
        int y = 8;

        Calc( x, y );

        cout << "theta = " << theta
             << ", or "
             << ( 180.0 * theta / 3.14159 )
             << " degrees\n";
        cout << "theta should be 0.785398, or 45 degrees\n";
        return 1;
}
