VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Graphical menu"
   ClientHeight    =   4185
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5355
   LinkTopic       =   "Form1"
   ScaleHeight     =   4185
   ScaleWidth      =   5355
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pctText 
      AutoRedraw      =   -1  'True
      Height          =   1335
      Left            =   0
      ScaleHeight     =   1275
      ScaleWidth      =   5115
      TabIndex        =   0
      Top             =   1380
      Visible         =   0   'False
      Width           =   5175
   End
   Begin VB.Menu mnuFonts 
      Caption         =   "&Fonts"
      Begin VB.Menu mnuFont 
         Caption         =   "Item"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'---- SubClasser
Dim WithEvents sc As SubClasser
Attribute sc.VB_VarHelpID = -1

'---- Initialisations
Private Sub Form_Load()
    ' PictureBox
    pctText.ScaleMode = vbPixels
    
    ' VB menu creation
    Dim i
    For i = 1 To Screen.FontCount - 1
        Load mnuFont(i)
        mnuFont(i).Visible = True
        mnuFont(i).Caption = Screen.Fonts(i)
    Next
    
    ' Modify menu items
    Dim hMenu As Long
    ' First submenu handle
    hMenu = GetSubMenu(GetMenu(Me.hwnd), 0)
    ' Loop on menu items
    For i = 0 To GetMenuItemCount(hMenu) - 1
        ' Set OwnerDraw style
        ModifyMenu hMenu, i, MF_BYPOSITION + MF_OWNERDRAW, _
                GetMenuItemID(hMenu, i), ByVal CLng(i)
    Next
    
    ' Subclass form
    Set sc = New SubClasser
    sc.SubClass Me.hwnd
End Sub

'---- Terminate
Private Sub Form_Unload(Cancel As Integer)
    ' Remove subclassing
    sc.ReClass
End Sub

'---- Selection of an item in the menu
Private Sub mnuFont_Click(Index As Integer)
    ' Prints font name, using font
    Me.Cls
    Me.Font.Name = Screen.Fonts(Index)
    Me.Font.Size = 20
    Me.Print "Hello in " & Me.Font.Name
End Sub

'---- Process window messages
Private Sub sc_WindowMessage(ByVal hwnd As Long, ByVal uMsg As Long,_
        ByVal wParam As Long, ByVal lParam As Long, Result As Long,_
        CallDefault As Boolean)
    ' Flag to call previous window procedure
    CallDefault = True

    ' Process message
    Select Case uMsg
        Case WM_MEASUREITEM
            ' MEASUREITEMSTRUCT structure
            Dim mi As MEASUREITEMSTRUCT
            ' Get it
            MemCopy mi, ByVal lParam, Len(mi)
            
            ' Process
            MeasureItem mi
            
            ' Copy back MEASUREITEMSTRUCT structure
            MemCopy ByVal lParam, mi, Len(mi)
            
            ' Result
            Result = True
            CallDefault = False
        
        Case WM_DRAWITEM
            ' DRAWITEMSTRUCT structure
            Dim di As DRAWITEMSTRUCT
            ' Get it
            MemCopy di, ByVal lParam, Len(di)
            
            ' Process
            DrawItem di

            ' Copy back DRAWITEMSTRUCT struct
            MemCopy ByVal lParam, di, Len(di)
            
            ' Result
            Result = True
            CallDefault = False
    End Select
End Sub

'---- Process WM_MEASUREITEM message
Private Sub MeasureItem(mi As MEASUREITEMSTRUCT)
    Dim txtFont As String
    ' Compute text dimensions using font
    txtFont = Screen.Fonts(mi.itemData)
    With pctText
        .Font.Name = txtFont
        .Font.Size = 10
        mi.itemWidth = .TextWidth(txtFont)
        mi.itemHeight = .TextHeight(txtFont)
    End With
End Sub

'---- Process WM_DRAWITEM message
Private Sub DrawItem(di As DRAWITEMSTRUCT)
    With pctText
        ' Draw color
        If di.itemState And ODS_SELECTED Then
            .ForeColor = vbHighlightText
            .BackColor = vbHighlight
        Else
            .ForeColor = vbMenuText
            .BackColor = vbMenuBar
        End If
        
        Dim txtFont As String
        ' Text = font name
        txtFont = Screen.Fonts(di.itemData)
        With .Font
            .Name = txtFont
            .Size = 10
            .Bold = False
            .Italic = False
            .Strikethrough = False
            .Underline = False
        End With
        .Cls
    End With
    pctText.Print txtFont
    
    ' Bitblt text to menu
    With di.rcItem
        BitBlt di.hdc, .Left + GetMenuCheckMarkDimensions(), .Top, _
            .Right-.Left, .Bottom-.Top, pctText.hdc, 0, 0, SRCCOPY
    End With
End Sub
