VERSION 5.00
Begin VB.Form VB_Error_Demo 
   Caption         =   "VB Error Test"
   ClientHeight    =   2265
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   3240
   LinkTopic       =   "Form1"
   ScaleHeight     =   2265
   ScaleWidth      =   3240
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      Height          =   5410
      Left            =   0
      ScaleHeight     =   1000
      ScaleMode       =   0  'User
      ScaleWidth      =   1000
      TabIndex        =   0
      Top             =   0
      Width           =   6970
   End
   Begin VB.Menu IDD_DRAW_DIRECT 
      Caption         =   "DLL Tests"
      Begin VB.Menu ErrorMessage 
         Caption         =   "Error Message"
      End
      Begin VB.Menu PopupMessage 
         Caption         =   "Popup Message"
      End
   End
End
Attribute VB_Name = "VB_Error_Demo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function ReportStdError Lib "ErrorShell.DLL" (ByVal hAppKey As Long, ByVal errNumber As Long, ByVal errType As Long, ByVal delay As Long, ByVal szMsg As String, ByVal scCaptions As String, ByVal szTitle As String) As Long
'EXPORT int  CALLBACK ReportStdError(                         HKEY  hAppKey, int errNumber,           int errType,           UINT delay,                  char * pszMsg,         char * pszCaptions = "",    char * pszTitle = "" );
Private Declare Function ReportPopup Lib "ErrorShell.DLL" (ByVal delay As Long, ByVal wAlign As Long, ByVal xPos As Long, ByVal yPos As Long, ByVal szMsg As String) As Long
'EXPORT void CALLBACK    ReportPopup(                      UINT delay,          WORD wAlign,          int xPos,           int yPos,           char * pszMsg   );

                          ' C/C++ Enumeration declarations
                          ' Enum ERRORTYPE
                          ' {
Const NULL_ERROR = 0      '     NULL_ERROR,      // no error
Const USER_ERROR = 1      '     USER_ERROR,
Const INFORMATION = 2     '     INFORMATION,
Const NON_CRITICAL = 3    '     NON_CRITICAL,
Const SEVERE_ERROR = 4    '     SEVERE_ERROR,
Const RETRY_ERROR = 5     '     RETRY_ERROR,
Const POPUP_MESSAGE = 6   '     POPUP_MESSAGE    // special for popup window
                          ' };

                          ' Enum POPUP_ALIGNMENT
                          ' {
Const POPUP_TOP = 0       '     POPUP_TOP = 0,   // default reference point above
Const POPUP_LEFT = 0      '     POPUP_LEFT = 0,  // default reference point at left
Const POPUP_RIGHT = 2     '     POPUP_RIGHT = 2,
Const POPUP_BOTTOM = 4    '     POPUP_BOTTOM = 4
                          ' };
                              
                              '   *** C code structure definition ***
Private Type ErrorMsg2        '   typedef struct tag_ERRORMSG2
                              '   {
    pszErrorString As String  '       char*       pszErrorString;
    nErrorCode As Long        '       UINT        nErrorCode;
    ERRORTYPE As Integer      '       ERRORTYPE   ErrorType;
End Type                      '   }   ERRORMSG2;

Public hAppKey As Long

Private Sub Form_Load()
    

    Dim lResult As Long
    Dim SA As SECURITY_ATTRIBUTES
    Dim szDir As String

'       open (or create) a registry key where the error log path
'       and file name will be found ... use the app name to identify
'       the log location for this specific application only
    RegCreateKeyEx HKEY_LOCAL_MACHINE, _
                   "Software\Error Logs\VB Error Demo", _
                   0, _
                   "", _
                   REG_OPTION_NON_VOLATILE, _
                   KEY_ALL_ACCESS, _
                   SA, _
                   hAppKey, _
                   Create
    
    If (Create = REG_CREATED_NEW_KEY) Then
'           Because this is a new registry entry, we need to set
'           an error log path and file name entry
        szDir = CurDir() & "\VB Error Demo.LOG"
        RegSetValueEx hAppKey, _
                      "Error Log Name", _
                      0, _
                      REG_SZ, _
                      szDir, _
                      CLng(Len(szDir) + 1)
    End If

End Sub

Private Sub ErrorMessage_Click()

    Dim strMsg As String
    Dim strCaptions As String
    Dim strTitle As String
    Dim nError As Long
    Dim errType As Long
    Dim nDelay As Long
    Dim nResult As Integer
    
    strMsg = "This is an error report generated by a Visual Basic application|This is explanation text|And this is the suggested response (displayed by a VC++ DLL)"
    nError = 101
    errType = USER_ERROR
    nDelay = 30
    strCaptions = "Event Report||Action|"
    strTitle = "VB Report"
    
    nResult = ReportStdError(hAppKey, nError, errType, nDelay, strMsg, strCaptions, strTitle)
    
End Sub

Private Sub PopupMessage_Click()
    
    Dim strMsg As String
    Dim nAlign As Long
    Dim nDelay As Long
    Dim xPos As Long
    Dim yPos As Long
    
    xPos = 100
    yPos = 100
    nAlign = POPUP_TOP + POPUP_LEFT
    strMsg = "This is a popup message"
    nDelay = 15
    
    ReportPopup nDelay, nAlign, xPos, yPos, strMsg  ', nLen

End Sub
