#===============================================#
# Nmake macros for building Windows 32-bit apps #
#===============================================#

!include <ntwin32.mak>

# instruction allows NMAKE to work

all: template.exe

# update resource as required
template.res: template.rc template.h
   rc -r -fo template.tmp template.rc
   cvtres -$(CPU) template.tmp -o template.res
   del template.tmp

# update object file as required
template.obj: template.c template.h
   $(cc) $(cflags) $(cvars) template.c

# update executable file if necessary
#   if updated, restore resources
template.exe: template.obj template.res template.def
   $(cvtobj) $(cvtdebug) *.obj
   $(link) $(guiflags) -out:template.exe template.obj \
      template.res $(guilibs)

