// KeycodesView.h : interface of the CKeycodesView class
//
/////////////////////////////////////////////////////////////////////////////

class CKeycodesView : public CView
{
protected: // create from serialization only
	CKeycodesView();
	DECLARE_DYNCREATE(CKeycodesView)

// Attributes
public:
	CKeycodesDoc* GetDocument();
protected:
	int	m_cyChr, m_cxChr, m_cyWin;
	CRect	m_cRect;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeycodesView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CKeycodesView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void ShowKey( int, BOOL, CString, UINT, LONG );

// Generated message map functions
protected:
	//{{AFX_MSG(CKeycodesView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in KeycodesView.cpp
inline CKeycodesDoc* CKeycodesView::GetDocument()
   { return (CKeycodesDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
