// Guru.cpp : implementation file
//

#include "stdafx.h"
#include "Reg_Ops.h"
#include "Guru.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGuru dialog


CGuru::CGuru(CWnd* pParent /*=NULL*/)
	: CDialog(CGuru::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGuru)
	m_csKeyName = _T("");
	//}}AFX_DATA_INIT
}


void CGuru::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGuru)
	DDX_Text(pDX, IDC_EDIT1, m_csKeyName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGuru, CDialog)
	//{{AFX_MSG_MAP(CGuru)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuru message handlers

BOOL CGuru::OnInitDialog() 
{
	unsigned long ulSize, ulType;
	HKEY	hSecretKey;
	char	szBuff[MAX_PATH+1];

	CDialog::OnInitDialog();
	RegCreateKey( HKEY_LOCAL_MACHINE, "SOFTWARE\\Not Very Secret", &hSecretKey );
	ulSize = sizeof( szBuff );
	if( RegQueryValueEx( hSecretKey, "Secret Key", NULL, &ulType, 
						 (LPBYTE) szBuff, &ulSize ) != ERROR_SUCCESS )
	{
		MessageBox( "Hey, if you can't even set up the registry correctly,\r\n"
					"how do you expect to be a system guru?  Sorry ..." );
		CDialog::OnCancel();
	}
	else
		m_csStrKey = szBuff;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGuru::OnOK() 
{
	UpdateData( TRUE );
	if( m_csKeyName.IsEmpty() || m_csKeyName != m_csStrKey )	
	{
		MessageBox( "Sorry, guess you're just not guru material" );
		CDialog::OnCancel();
		return;
	}
	CDialog::OnOK();
}

