//      JUMPS_B
//      Shows what should happen when a goto statement jumps out of
//      the try block in an exception handler.

#include <windows.h>
#include <stdio.h>
#include <conio.h>

int main()
{
    char *szText = NULL;

    __try
    {
        puts( "In try block." );
        goto label1;
    }
    __except( EXCEPTION_EXECUTE_HANDLER )
    {
        puts( "In except block." );         // this line doesn't happen
    }

label1:
    puts( "Jumped to 'label1'; forcing an exception." );
    lstrcpy( szText, "Error" );             // writes to NULL pointer
    puts( "Ending program." ); 
	getch();								// pause for keyboard hit
    return( 0 );
}
