unit mainwin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, MSHTML;

type
  TfrmMainWin = class(TForm)
    HTML: THTML;
    UrlBox: TComboBox;
    procedure FormResize(Sender: TObject);
    procedure UrlBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HTMLBeginRetrieval(Sender: TObject);
    procedure UrlBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMainWin: TfrmMainWin;

implementation

{$R *.DFM}
CONST
  DEFAULT_PAGE = 'www.webcrawler.com';

procedure TfrmMainWin.FormResize(Sender: TObject);
begin
  UrlBox.width:= ClientWidth;
  Html.width:= ClientWidth;
  Html.height:= ClientHeight - UrlBox.Height;
end;

procedure TfrmMainWin.UrlBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_RETURN) then Html.RequestDoc( UrlBox.Text );
end;

procedure TfrmMainWin.HTMLBeginRetrieval(Sender: TObject);
var  i: integer;  found: boolean;
begin
  found:= FALSE;
  for i:= 0 to UrlBox.Items.Count -1 do
    if (UrlBox.Items[i] = Html.Url) then begin
      found:= TRUE;
      break;
    end;
  if (not found) then
    UrlBox.Items.Add( Html.Url );
  UrlBox.Text:= Html.Url;
end;

procedure TfrmMainWin.UrlBoxClick(Sender: TObject);
begin
  Html.RequestDoc( UrlBox.Text );
end;

procedure TfrmMainWin.FormCreate(Sender: TObject);
begin
  Html.RequestDoc( Default_Page );
end;

end.
