unit mainwin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmMainWin = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMainWin: TfrmMainWin;

implementation

{$R *.DFM}

procedure TfrmMainWin.Button1Click(Sender: TObject);
var  nr: TNetResource;
     szErrorMessage, szLocalName, szRemoteName: ShortString;
begin
  // Clear NetResource structure, load local and remote names.
  Cursor:= crHourGlass;
  Button1.Cursor:= Cursor;
  fillchar(nr, sizeof(nr), #0);
  strpcopy(@szLocalName, Edit2.Text);
  strpcopy(@szRemoteName, Edit1.Text);

  // Now, fill NetResource fields.
  with nr do
  begin
    dwType:= RESOURCETYPE_DISK;
    lpLocalName:= @szLocalName;
    lpRemoteName:= @szRemoteName;
  end;

  // Call WNetAddConnection2, using default username and password.
  if (WNetAddConnection2( nr, NIL, NIL, 0) <> NO_ERROR) then
  begin
    // If any error occurred, retrieve the system error text and display it.
    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, NIL, GetLastError,
      LANG_SYSTEM_DEFAULT, @szErrorMessage, sizeof(szErrorMessage), NIL);
    ShowMessage('Error attempting connection: '+strpas(@szErrorMessage));
  end
  else
    ShowMessage(Edit1.Text
      +' has been successfully connected and mapped to '+Edit2.Text);

  Cursor:= crDefault;
  Button1.Cursor:= Cursor;
end;

end.
