// CntrItem.h : interface of the COle_ClientCntrItem class
//

class COle_ClientDoc;
class COle_ClientView;

class COle_ClientCntrItem : public COleClientItem
{
	DECLARE_SERIAL(COle_ClientCntrItem)

// Constructors
public:
	COle_ClientCntrItem(COle_ClientDoc* pContainer = NULL);
		// Note: pContainer is allowed to be NULL to enable IMPLEMENT_SERIALIZE.
		//  IMPLEMENT_SERIALIZE requires the class have a constructor with
		//  zero arguments.  Normally, OLE items are constructed with a
		//  non-NULL document pointer.

// Attributes
public:
	COle_ClientDoc* GetDocument()
		{ return (COle_ClientDoc*)COleClientItem::GetDocument(); }
	COle_ClientView* GetActiveView()
		{ return (COle_ClientView*)COleClientItem::GetActiveView(); }

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COle_ClientCntrItem)
	public:
	virtual void OnChange(OLE_NOTIFICATION wNotification, DWORD dwParam);
	virtual void OnActivate();
	protected:
	virtual void OnGetItemPosition(CRect& rPosition);
	virtual void OnDeactivateUI(BOOL bUndoable);
	virtual BOOL OnChangeItemPosition(const CRect& rectPos);
	//}}AFX_VIRTUAL

// Implementation
public:
	~COle_ClientCntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	virtual void Serialize(CArchive& ar);
};

/////////////////////////////////////////////////////////////////////////////
