// ParryView.cpp : implementation of the CParryView class
//

#include "stdafx.h"
#include "Parry.h"
//	#include <stdlib.h>
//	#include <stdio.h>
#include <time.h>


#include "ParryDoc.h"
#include "ParryView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParryView

IMPLEMENT_DYNCREATE(CParryView, CView)

BEGIN_MESSAGE_MAP(CParryView, CView)
	//{{AFX_MSG_MAP(CParryView)
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_COMMAND(ID_SCAN, OnScan)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParryView construction/destruction

CParryView::CParryView()
{
	// TODO: add construction code here

}

CParryView::~CParryView()
{
}

BOOL CParryView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CParryView drawing

void CParryView::OnDraw(CDC* pDC)
{
	CParryDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CString csText = "Paranoid Scanning Services";

	pDC->TextOut( 10, 10, csText );
}

/////////////////////////////////////////////////////////////////////////////
// CParryView printing

BOOL CParryView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CParryView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CParryView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// OLE Server support

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the server (not the container) causes the deactivation.
void CParryView::OnCancelEditSrvr()
{
	GetDocument()->OnDeactivateUI(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CParryView diagnostics

#ifdef _DEBUG
void CParryView::AssertValid() const
{
	CView::AssertValid();
}

void CParryView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CParryDoc* CParryView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CParryDoc)));
	return (CParryDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CParryView message handlers

void CParryView::OnScan() 
{
	CDialog *pDlg;
	UINT	 nDlg;

	// Seed the random-number generator with current time so that
	//	the numbers will be different every time we run.
	srand( (unsigned)time( NULL ) );
	switch( ( rand() % 10 ) + 1 )
	{
		case 1:		nDlg = IDD_DIALOG1;		break;
		case 2:		nDlg = IDD_DIALOG2;		break;
		case 3:		nDlg = IDD_DIALOG3;		break;
		case 4:		nDlg = IDD_DIALOG4;		break;
		case 5:		nDlg = IDD_DIALOG5;		break;
		default:	nDlg = IDD_DIALOG6;		break;
	}
	if( nDlg != IDD_DIALOG6 )
		MessageBeep( MB_ICONEXCLAMATION );
	pDlg = new CDialog( nDlg, NULL );
	pDlg->DoModal();
	delete pDlg;
}
