#include <stdlib.h>
#include <string.h>
#include <windows.h>


LRESULT CALLBACK WindProc(HWND, UINT, WPARAM, LPARAM);

HWND    EditWindow;
HANDLE  AppInstance;

LONG    Selection;


int PASCAL WinMain(HINSTANCE Instance,
    HINSTANCE Previous, LPSTR CmdLine, int Command)
    {
    static  char AppName[] = "wwedit";
    HWND        MainWindow;
    WNDCLASS    WindowClass;
    MSG         Message;

    if(CmdLine);

    AppInstance = Instance;
    if(!Previous)
        {
        WindowClass.style           = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
        WindowClass.lpfnWndProc     = WindProc;
        WindowClass.cbClsExtra      = 0;
        WindowClass.cbWndExtra      = 0;
        WindowClass.hInstance       = Instance;
        WindowClass.hIcon           = LoadIcon(NULL, IDI_APPLICATION);
        WindowClass.hCursor         = LoadCursor(NULL, IDC_ARROW);
        WindowClass.hbrBackground   = GetStockObject(WHITE_BRUSH);
        WindowClass.lpszMenuName    = NULL;
        WindowClass.lpszClassName   = AppName;
        RegisterClass(&WindowClass);
        }

    MainWindow  = CreateWindow(AppName, AppName,
            WS_OVERLAPPEDWINDOW,
            CW_USEDEFAULT,
            CW_USEDEFAULT,
            200,
            200,
            NULL,
            NULL,
            Instance,
            NULL);

    LoadLibrary("c:\\usr\\bl\\src\\dndedit\\dndedit.dll");
    ShowWindow(MainWindow, Command);
    UpdateWindow(MainWindow);
    if(!GetClassInfo(Instance, "DndEdit", &WindowClass))
        FatalAppExit(0, "Class DndEdit does not exist");

DialogBox(AppInstance, "TestDialog", MainWindow, (DLGPROC)DefDlgProc);
    EditWindow  = CreateWindow("DndEdit", "WindowName",
        WS_CHILD|WS_VISIBLE|WS_BORDER|ES_MULTILINE|ES_LEFT|WS_TABSTOP
        |WS_VSCROLL|WS_HSCROLL
        |ES_AUTOVSCROLL|ES_AUTOHSCROLL,
        10, 20, 100, 100, MainWindow, (HMENU)-1, Instance, NULL);
    if(EditWindow == NULL)
        FatalAppExit(0, "Cannot create DndEdit window");


/* Temporary hack - fill window with text for debugging convenience */

{
int i, j, k;
char	*Buffer = malloc(4000), *Text = Buffer;


	*Buffer	= '\0';	
	for(i = 0; i < 50; ++i)
		{
		if(!(i%5))
			k		= 22;
		else
			k		= 5;
		for(j = 0; j < k; ++j)
			*Buffer++	= ' '+i+1;
		*Buffer++	= '\r';
		*Buffer++	= '\n';
		}
	*Buffer++	= '\0';

    SendMessage(EditWindow, WM_SETTEXT, 0, (DWORD)(char far *)Text);
	free(Buffer);
}

#if 0 /* for testing other fonts */
{
LOGFONT FontDesc;
HFONT   Font;

memset(&FontDesc, 0, sizeof(FontDesc));
strcpy(FontDesc.lfFaceName, "Modern");
FontDesc.lfHeight   = 24;
FontDesc.lfCharSet  = OEM_CHARSET;
Font    = CreateFontIndirect(&FontDesc);
if(Font)
    {
/*    MessageBeep(1); */ 
    SendMessage(EditWindow, WM_SETFONT, (WPARAM)Font, 1);
    }
}
#endif


ShowWindow(EditWindow, Command);
UpdateWindow(EditWindow);
	SetFocus(EditWindow);
    while(GetMessage(&Message, NULL, 0, 0))
        {
        TranslateMessage(&Message);
        DispatchMessage(&Message);
        }
    return Message.wParam;
    }


LRESULT CALLBACK WindProc(HWND WindowHandle,
        UINT MsgNum, WPARAM WordParm, LPARAM LongParm)
    {
    switch(MsgNum)
        {
        case    WM_DESTROY:
            PostQuitMessage(0);
            return 0;
        default:
            return DefWindowProc(WindowHandle, MsgNum, WordParm, LongParm);
        }
    }



