#include <windows.h>

int IlwFindLwRglw(DWORD lw, DWORD far lrglw[], int clw)
/*****************************************************/
/* -- Find the 32 bit value in the array of 32 bit   */
/*    values.                                        */
/* -- Return its index if found, else -1.            */
/* -- lw    : Value to search for.                   */
/* -- lrglw : Array to search.                       */
/* -- clw   : Number of elements in array.           */
/*****************************************************/
    {
    int ilw;

    _asm
        {
        _emit   0x66
        mov     ax, WORD PTR lw ; mov     eax, lw
        _emit   0x66
        xor     cx, cx          ; xor     ecx, ecx
        mov     cx, clw
        _emit   0x66
        xor     di, di          ; xor     edi, edi
        les     di, lrglw
        _emit    0x66
        repne   scasw           ; repne   scasd
        je      Found
        mov     ilw, -1
        jmp     Exit

Found:
        sub     di, WORD PTR lrglw
        shl     di, 2
        dec     di
        mov     ilw, di
        }
Exit:
    return ilw;
    }
