/*****************************************************/
/* symbase.h                                         */
/* -- Interface to hook framework for hooks.         */
/*****************************************************/
typedef struct
    {
    HTASK   htsk;       /* Client task handle. */
    HFONT   hfnt;       /* Font to mix. */
    } CDS, FAR * LPCDS; /* Client Data Struct. */

typedef struct
    {
    FARPROC lpfnOrig;   /* Function being hooked. */
    BYTE    bJump;      /* Far jump instruction. */
    FARPROC lpfnHook;   /* Hook proc. */
    BYTE    rgbCode[5]; /* Code to remember. */
    } HKS;              /* HooK Structure. */

LPCDS   LpcdsGetCur(void);

/* Hook out (or restore) the given function. */
#define HookHks(phks, fHook)                          \
    MemoryWrite(SELECTOROF((phks)->lpfnOrig),         \
        OFFSETOF((phks)->lpfnOrig),                   \
      (fHook) ? &(phks)->bJump : (phks)->rgbCode,     \
      sizeof (phks)->rgbCode)

