      include 'winapi.for'
c
$nolist
      include 'flib.fi'
$list
$page
      PROGRAM ALC_SIM
$nolist
      include 'flib.fd'
$list
      common /matl/ nblood, nsweat, ntoil, ntears, nlead, ngold
      integer*2 hwnd
      common /winstuff/ hwnd
      integer*2 GetFocus
c
      structure /s_rect/
        integer*2 left, top, right, bottom
      endstructure
      record /s_rect/ wndsize[FAR], oldsize
c
      nblood = 0
      nsweat = 0
      ntoil  = 0
      ntears = 0
      nlead  = 0
      nlead  = 0
c
      oldsize.left   = 0
      oldsize.top    = 0
      oldsize.right  = 0
      oldsize.bottom = 0
c
      hwnd=getfocus()                   ! Note, no arguments needed
      call draw_form
c
      is0 = 0
  100 call yieldqq()                    ! Let Windows do something else
      call gettim(ih,im,is,ic)          ! Get the current time
      if (is.eq.is0) go to 100          ! Wait until the next second
      is0 = is
c     Find out if the client area has changed and,
c     if so, redraw the form
c
      call GetClientRect(hwnd,wndsize)  ! Get size of client
      if ((wndsize.left   .ne. oldsize.left)    .or.
     &    (wndsize.top    .ne. oldsize.top)     .or.
     &    (wndsize.right  .ne. oldsize.right)   .or.
     &    (wndsize.bottom .ne. oldsize.bottom)) call draw_form
      oldsize.left   = wndsize.left
      oldsize.top    = wndsize.top
      oldsize.right  = wndsize.right
      oldsize.bottom = wndsize.bottom
c     Check the random deliveries from our unreliable suppliers
c
      call random(r)                    ! Prob of getting blood today
      if (r.gt.0.5) nblood = nblood + 1 ! If P>0.5, we got some
      call random(r)                    ! Same for sweat
      if (r.gt.0.5) nsweat = nsweat + 1
      call random(r)                    ! for toil,
      if (r.gt.0.5) ntoil  = ntoil  + 1
      call random(r)                    ! for tears,
      if (r.gt.0.5) ntears = ntears + 1
      call random(r)                    ! and for lead.
      if (r.gt.0.5) nlead  = nlead  + 1
      call draw_data                    ! Write updated values
c     If not enough raw materials, go back and wait for some
c
      if (nblood.lt.3) go to 100
      if (nsweat.lt.3) go to 100
      if (ntoil .lt.3) go to 100
      if (ntears.lt.3) go to 100
      if (nlead .lt.3) go to 100
c     We have enough to process into gold
c      
      nblood = nblood - 3               ! Decrement the inventory
      nsweat = nsweat - 3               ! as we use the raw matls
      ntoil  = ntoil  - 3
      ntears = ntears - 3
      nlead  = nlead  - 3
      ngold  = ngold  + 1               ! Incr the gold balance
      call draw_data                    ! Write updated values
      if (ngold.lt.10) go to 100        ! Loop back if not enough
c     Abscond to Brasil with the gold
c
      stop 'Bye!'
      end
      SUBROUTINE DRAW_FORM
      integer*2 hwnd, hdc, hfont, hfontold
      common /winstuff/ hwnd
      integer*2 GetDC, ReleaseDC, SetTextColor, TextOut
      integer*2 GetStockObject, SelectObject
c     This subroutine draws the "form," that part of
c     the image does not routinely change.
c
      hdc = GetDC(hwnd)
      hfont = GetStockObject(16)          ! 16 = SYSTEM_FIXED_FONT
      hfontold = SelectObject(hdc,hfont)  ! Use that font
c
      istat = SetTextColor(hdc,#00000000) ! Black characters
      istat = TextOut(hdc,10, 30,'ALCHEMY SIMULATION',18)
      istat = TextOut(hdc,10, 50,'Blood:',6)
      istat = TextOut(hdc,10, 70,'Sweat:',6)
      istat = TextOut(hdc,10, 90,'Toil :',6)
      istat = TextOut(hdc,10,110,'Tears:',6)
      istat = TextOut(hdc,10,130,'Lead :',6)
      istat = TextOut(hdc,10,150,'Gold :',6)
c
      hfont = SelectObject(hdc,hfontold)  ! Switch to default font
      is = ReleaseDC(hwnd,hdc)            ! Return device context
c
      return
      end
      SUBROUTINE DRAW_DATA
      common /matl/ nblood, nsweat, ntoil, ntears, nlead, ngold
      integer*2 hwnd, hdc, hfont, hfontold
      common /winstuff/ hwnd
      integer*2 GetDC, ReleaseDC, SetTextColor, TextOut
      integer*2 GetStockObject, SelectObject
      character*6 cbuf
c     This subroutine draws the variable data
c
      hdc = GetDC(hwnd)
      hfont = GetStockObject(16)          ! 16 = SYSTEM_FIXED_FONT
      hfontold = SelectObject(hdc,hfont)  ! Load that font for use
c
      istat = SetTextColor(hdc,#00FF0000) ! Blue characters
      write (cbuf,40) nblood
   40 format (I6)
      istat = TextOut(hdc,60, 50,cbuf,6)
      write (cbuf,40) nsweat
      istat = TextOut(hdc,60, 70,cbuf,6)
      write (cbuf,40) ntoil
      istat = TextOut(hdc,60, 90,cbuf,6)
      write (cbuf,40) ntears
      istat = TextOut(hdc,60,110,cbuf,6)
      write (cbuf,40) nlead
      istat = TextOut(hdc,60,130,cbuf,6)
      istat = SetTextColor(hdc,#00007F00) ! Dark Green characters
      write (cbuf,40) ngold
      istat = TextOut(hdc,60,150,cbuf,6)
c
      hfont = SelectObject(hdc,hfontold)  ! Return to default font
      is = ReleaseDC(hwnd,hdc)            ! Give back device context
c
      return
      end
