// wuierror.h - WUIMAN error code definitions.

#ifndef WUIERROR_H
#define WUIERROR_H

#include <limits.h>

// Some object name in the path did not exist
const   long    WUIMAN_ERR_BAD_PATH     = (LONG_MIN+1);
// Target does not support the specified attribute
const   long    WUIMAN_ERR_BAD_ATTR     = (LONG_MIN+2);

// So adding new errors may not immediately
// break existing code.
const   long    WUIMAN_ERR_SLOP         = 100;

// use "if(Error < WUIMAN_ERRORS)" to detect
// an error.
const   long    WUIMAN_ERRORS           = (LONG_MIN+2
                                          +WUIMAN_ERR_SLOP);
#endif
