/*****************************************************/
/* colordlg.c                                        */
/* -- Program demonstrates customizing the standard  */
/*    color dialog.                                  */
/* -- To build: "cc -DSTRICT colordlg.c commdlg.lib" */
/*****************************************************/
#include <windows.h>
#include <commdlg.h>
#include <colordlg.h>

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
                                      LPSTR lpsz, int wShow)
    {
    CHOOSECOLOR chc;
    COLORREF    rgclr[16];

    chc.lStructSize = sizeof chc;
    chc.hwndOwner = NULL;
    chc.hInstance = (HWND)hins;
    chc.lpCustColors = rgclr;
    chc.Flags = CC_FULLOPEN | CC_ENABLETEMPLATE;
    chc.lpTemplateName = "ChooseColor";

    if (ChooseColor(&chc))
        {
        char    szBuf[128];

        wsprintf(szBuf, "RGB = (%d, %d, %d)",
          GetRValue(chc.rgbResult),
          GetGValue(chc.rgbResult),
          GetBValue(chc.rgbResult));
        MessageBox(NULL, szBuf, "ColorDlg", MB_OK);
        }

    return 0;
    }
