#ifndef OBJTHUNK_H
#define OBJTHUNK_H

#if !(defined(_INC_WINDOWS) || defined(__WINDOWS_H))
    #include <windows.h>
#endif

class    Thunkable;    // Forward Reference so we can define THUNKPROC

typedef void (CALLBACK Thunkable::* THUNKPROC)(void);

class    Thunkable
{
public:
    Thunkable(THUNKPROC Pointer);
    virtual ~Thunkable();
    operator FARPROC() { return ThunkProcedure; }
private:
    // declare but don't define
    Thunkable(const Thunkable&);
    const Thunkable &operator=(const Thunkable&);

    FARPROC     MakeThunk(THUNKPROC lpmfnFunc);
    void        FreeThunk(FARPROC lpfnFunc);

    FARPROC     ThunkProcedure;
};

#endif    OBJTHUNK_H
