#include "timer.h"

Timer::Timer()
    : Thunkable((THUNKPROC)&Timer::TimerProc), TimerId(0)
{
}

Timer::~Timer()
    {
    Stop();
    }

int    Timer::Start(UINT Timeout)
    {
    if(TimerId)
        Stop();
    TimerId = SetTimer(NULL, 0, Timeout,
                                 (TIMERPROC)(FARPROC)*this);
    return TimerId;
    }

int    Timer::Stop()
    {
    if(TimerId)
        {
	KillTimer(NULL, TimerId);
        TimerId     = 0;
        return TRUE;
        }
    else
        return FALSE;
    }

// dummy virtual callback -- override in your own class.
void CALLBACK Timer::TimerProc(HWND /*hWnd*/,
        UINT /*Message*/, UINT /*TimerID*/, DWORD /*Time*/)
{
    
}
