// bmpvw.cpp : implementation of the CBmpView class
//

#include "stdafx.h"
#include "db_bmp.h"

#ifndef _BmpDoc_
#include "bmpdoc.h"
#endif

#ifndef _BmpVw_
#include "bmpvw.h"
#endif

#ifndef _UpdBmpDB_
#include "updbmpdb.h"
#endif

#ifndef _DispBmp_
#include "dispbmp.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmpView

IMPLEMENT_DYNCREATE(CBmpView, CView)

BEGIN_MESSAGE_MAP(CBmpView, CView)
    //{{AFX_MSG_MAP(CBmpView)
    ON_COMMAND(IDMI_BMP_LOAD, OnBmpLoad)
    ON_COMMAND(IDMI_BMP_STORE, OnBmpStore)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpView construction/destruction

CBmpView::CBmpView()
{
    // TODO: add construction code here
}

CBmpView::~CBmpView()
{
}


void CBmpView::OnInitialUpdate(void)
{
    GetDocument()->OpenDatabase();
    
}



/////////////////////////////////////////////////////////////////////////////
// CBmpView drawing

void CBmpView::OnDraw(CDC* pDC)
{
    CBmpDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    // TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CBmpView diagnostics

#ifdef _DEBUG
void CBmpView::AssertValid() const
{
    CView::AssertValid();
}

void CBmpView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CBmpDoc* CBmpView::GetDocument() // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBmpDoc)));
    return (CBmpDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBmpView message handlers

void CBmpView::OnBmpLoad()
{
    // TODO: Add your command handler code here
    new DisplayBmp(this,GetDocument()->qryDatabase());
}

void CBmpView::OnBmpStore()
{
    // TODO: Add your command handler code here
    new UpdBmpDB(this,GetDocument()->qryDatabase());
    
}

