// updbmpdb.h : header file
//

#ifndef _UpdBmpDB_
#define _UpdBmpDB_


#ifndef __PICEDIT_H__
#include "picedit.h"
#endif


class dbBitmap;

/////////////////////////////////////////////////////////////////////////////
// UpdBmpDB dialog

class UpdBmpDB : public CDialog
{
    public:
        UpdBmpDB(CWnd*,CDatabase*);
        virtual ~UpdBmpDB(void);
        
        void DisplayBitmap(void);
        
    protected:
        CRect       bmpRect;
        dbBitmap*   pBmp;
        CPicEdit    txtBmpID;
        CDatabase*  pDB;
        
        //{{AFX_DATA(UpdBmpDB)
        enum { IDD = IDD_BMP_STORE };
        CString szDescr;
        CString szFile;
        CString szID;
        //}}AFX_DATA

        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        virtual void PostNcDestroy(void);
        
        //{{AFX_MSG(UpdBmpDB)
        afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
        afx_msg void OnPaint();
        virtual void OnCancel();
        afx_msg void OnSave();
        virtual BOOL OnInitDialog();
        afx_msg void OnBrowse();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};


#endif  // _UpdBmpDB_



