// bmpdoc.cpp : implementation of the CBmpDoc class
//

#include "stdafx.h"
#include "bmp_samp.h"

#include "bmpdoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmpDoc

IMPLEMENT_DYNCREATE(CBmpDoc, CDocument)

BEGIN_MESSAGE_MAP(CBmpDoc, CDocument)
	//{{AFX_MSG_MAP(CBmpDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpDoc construction/destruction

CBmpDoc::CBmpDoc()
{
    m_hBitmap = NULL;
    m_hPal = NULL;
}

CBmpDoc::~CBmpDoc()
{
}
 
void CBmpDoc::DeleteContents( )
{
    if (m_hBitmap) DeleteObject(m_hBitmap);   
    if (m_hPal) DeleteObject(m_hPal);          
    
    m_hBitmap = NULL;
    m_hPal = NULL;     
}
 
BOOL CBmpDoc::OnOpenDocument(const char *pszPathName)
{
    if (!CDocument::OnOpenDocument(pszPathName)) return FALSE;
   
    CreateBitmapFromFile((LPSTR)pszPathName, &m_hBitmap, &m_hPal);
        
    return TRUE;
}    

/////////////////////////////////////////////////////////////////////////////
// CBmpDoc serialization

void CBmpDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBmpDoc diagnostics

#ifdef _DEBUG
void CBmpDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBmpDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBmpDoc commands
