 
#include <windows.h>

VOID DisplaySystemMessage(HWND hWnd, UINT uiSystemError);

TCHAR pszErrorCaption[] = TEXT("System Message Sample Program");

//-----------------------------------------------------------------
VOID main(VOID)
{
   HANDLE hFile = NULL;

   hFile = CreateFile(TEXT("x.x"), GENERIC_READ, 0, NULL, OPEN_EXISTING,
      FILE_ATTRIBUTE_NORMAL, NULL);
   DisplaySystemMessage(NULL, GetLastError());
   if (hFile != NULL) CloseHandle(hFile);
   return; 
} // main

//------------------------------------------------------------------
VOID DisplaySystemMessage(HWND hWnd, UINT uiSystemError)
{
   TCHAR szMessage[MAX_PATH];

   // retrieve the string matching the Win32 system error
   FormatMessage(
            FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            uiSystemError,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL),
            szMessage,
            MAX_PATH,
            NULL);

   // display a message box with this error
   MessageBox(hWnd, szMessage, pszErrorCaption, MB_OK | MB_ICONSTOP);
   return;

} // DisplaySystemMessage
