#include <windows.h>
#include <stdio.h>
#include "rpctips.h"

void main(void)
{
  static char bareNSName[] = "Test";

  char    formattedNSName[256];
  char    myDomain[256];
  char    otherDomain[256];

  if (LookupDomain(myDomain, sizeof(myDomain)))
    printf("Current domain is: %s.\n", myDomain);
  else
    printf("Current domain is unknown.\n");

  strcpy(otherDomain, myDomain);
  strcat(otherDomain, "_XYZ");

  FormatNSName(myDomain, myDomain,
    bareNSName, formattedNSName);

  printf("To lookup name %s in domain %s, the syntax is: %s.\n",
    bareNSName, myDomain, formattedNSName);

  FormatNSName(myDomain, otherDomain,
    bareNSName, formattedNSName);

  printf("To lookup name %s in domain %s, the syntax is: %s.\n",
    bareNSName, otherDomain, formattedNSName);
}
