
/*
 * TESTCWD.C. Fri 05-03-1996. Compiled with TURBO C 2.0 (1988)
 */

#include <stdio.h>
#include <dos.h>
#include <direct.h>
#include <string.h>
#include <stdlib.h>

struct SREGS segregs;
union REGS regs;

void dosseg(void) {
  int86x(0x21,&regs,&regs,&segregs);
}

#define MAX95PATH (280) /* probaby really 260, but maybe
more; actually you're supposed to do a call.... */

/********************************************************
Wchdir; return -1 if bad else 0
*********************************************************/
int Wchdir(const char *path) {
  regs.x.ax=      0x713b;
  regs.x.dx=      FP_OFF(path);
  segregs.ds=     FP_SEG(path);
  dosseg();
  return
  regs.x.cflag ? -1 : 0;
}

enum {
  WIN95RUNNING=1,
  JUSTDOS7
};


int w95(void) {
  static char longname[]="U";
  char shortname[13];
  if (_osmajor < 7)
  return 0;

 /* I had some problem with
the recommended procedure so... */

  regs.x.ax = 0x71a8;
  segregs.ds = FP_SEG(longname);
  regs.x.si = FP_OFF(longname);
  segregs.es = FP_SEG(shortname);
  regs.x.di = FP_OFF(shortname);
  regs.x.dx = 0x0000;

  dosseg();

  return
  regs.x.cflag ?
  JUSTDOS7 :
  WIN95RUNNING;
}

/****************************************
Emulates TC getcwd; (DOS omits drive,
colon, slash.)
0123
c:\
****************************************/
char *Wgetcwd(char *buf, int buflen) {
  enum {
    NAME1=3
  };

  char apath[MAX95PATH+NAME1];

  getcwd(apath,MAX95PATH+NAME1);
  /* Wastefully use the old TC call to get the drive. */

  regs.x.ax=      0x7147;
  regs.h.dl=      0;      /* this drive. */
  regs.x.si=      FP_OFF(apath)+NAME1;
  segregs.ds=     FP_SEG(apath);

  dosseg();

  if (regs.x.cflag)
  return NULL;

  if (buf) {
    if (buflen<(strlen(apath)+1))
    return NULL;

    strcpy(buf,apath);
    return buf;
  }

  return
  strdup(apath);

}

/*********************************************************
**********************************************************/
void main(int argc, char *argv[]) {
  char buf[MAX95PATH];
  switch(w95()) {
    case JUSTDOS7:
    printf("DOS 7 but not W95");
    exit(7);

    case 0:
    printf("No W95");
    exit(1);
  }

  if (argc >1) {
    if (Wchdir(argv[1])) {
      printf("No such directory?");
      exit(2);
    }

    Wgetcwd(buf, MAX95PATH);
    printf("Wgetcwd result: %s\n",buf);
    Wchdir(".."); /* go back. */
  }
}

