#include "stdafx.h"
#include "stat.h"            

             
BEGIN_MESSAGE_MAP(CMyFrameWnd, CFrameWnd)
   ON_WM_CREATE()
   ON_WM_MENUSELECT()
END_MESSAGE_MAP()


//The Main Window constructor
CMyFrameWnd::CMyFrameWnd( void )
{
   Create(NULL, "Prompt for Popup - Demo", WS_OVERLAPPEDWINDOW,
      rectDefault, NULL, "MainMenu", 0, NULL);
}
  
  
//Create the status bar during the creation of Main Window
int CMyFrameWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   CFrameWnd::OnCreate(lpCreateStruct);
   
   UINT uIndicators = ID_SEPARATOR;
   m_wndStatusBar.Create(this);
   m_wndStatusBar.SetIndicators(&uIndicators, 1);

   return 0;
}


//Override default behaviour
void CMyFrameWnd::OnMenuSelect(UINT nItemID, UINT nFlags,
                             HMENU hSysMenu)
{  
   //If the option is a Popup and is hilighted
   if((nFlags&(MF_HILITE|MF_POPUP)) == (MF_HILITE|MF_POPUP))
   {  
      //Reset MF_POPUP flag
      nFlags &= ~MF_POPUP;

      //Replace the popup menu index with the 
      //unique ID assigned for the Popup
#ifndef OLD_WINDOWS
      nItemID = GetMenu()->GetSubMenu(nItemID)->GetMenuItemID(0) - 1;
#else
	  //In case of older windows use this, because in old windows
	  //nItemID is the handle of the Popup menu rather than the index.
	  nItemID = CMenu::FromHandle(HMENU(nItemID))->GetMenuItemID(0) - 1;
#endif
   }
   
   CFrameWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);
}


//Create the Main Window
BOOL CMyApp::InitInstance()
{ 
   m_pMainWnd = new CMyFrameWnd();
   m_pMainWnd->ShowWindow(m_nCmdShow);
   m_pMainWnd->UpdateWindow();

   return TRUE;
}


//Execute the application
CMyApp NEAR theApp; 
