#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "lptacces.h"

int main(int argc, char *argv[])
{                               // main
    HANDLE     hDevice;
    DWORD      cbBytesReturned;
    DWORD      dwErrorCode;
    unsigned   char ch;
    char       *pszPortName = "LPT1";

    hDevice = CreateFile("\\\\.\\LPTACCES.VXD", 0, 0, NULL, 0,
        FILE_FLAG_DELETE_ON_CLOSE, NULL);
    if (hDevice == INVALID_HANDLE_VALUE)
    {
      printf("Create failed\n");
      return 1;
    }          

    puts( "Press key to acquire");
    ch = getch();

    if (!DeviceIoControl(hDevice, LPTACCESS_FUNC_ACQUIRE, 
                       pszPortName, strlen(pszPortName), 
                       NULL, 0, &cbBytesReturned, NULL))
    {
       printf("Acquire %s failed, error %x\n",
            pszPortName, GetLastError() );
       goto closeit;     
    }

    puts( "Press key to release");
    ch = getch();

    if (!DeviceIoControl(hDevice, LPTACCESS_FUNC_RELEASE, 
                       pszPortName, strlen(pszPortName), 
                       NULL, 0, &cbBytesReturned, NULL))
    {
       printf("Release %s failed, error %x\n",
            pszPortName, GetLastError() );
       goto closeit;
    }

closeit:
    CloseHandle(hDevice);
    return 0;
}

