VERSION 5.00
Begin VB.Form frmLog 
   Caption         =   "Error Message Log"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5880
   Icon            =   "Log.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5880
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDelete 
      Caption         =   "&Delete"
      Default         =   -1  'True
      Height          =   540
      Left            =   3210
      TabIndex        =   2
      Top             =   2430
      Width           =   1110
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   540
      Left            =   1605
      TabIndex        =   1
      Top             =   2430
      Width           =   1110
   End
   Begin VB.ListBox lstLog 
      Height          =   1815
      Left            =   300
      TabIndex        =   0
      Top             =   375
      Width           =   5220
   End
End
Attribute VB_Name = "frmLog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public strLogFile As String

Private Sub ExitFrm()

frmDemo.Visible = True
Unload frmLog

End Sub


Private Sub cmdDelete_Click()

Dim hFile As Long
Dim strmsg As String

strmsg = "This will delete all records in the log file." & vbCrLf & vbCrLf
strmsg = strmsg & "Are you sure that you want to do this?"
If MsgBox(strmsg, vbQuestion Or vbYesNo, "Confirm Deletion") = vbYes Then
   hFile = FreeFile()
   Open strLogFile For Output As #hFile
   Write #hFile, ""
   Close #hFile

   lstLog.Clear
   ExitFrm
End If

End Sub


Private Sub cmdOK_Click()

ExitFrm


End Sub

Private Sub Form_Load()

Dim lngData As Long, lngFileNameLen As Long
Dim hFile As Long, lngPos As Long
Dim strItem As String

' Position form
frmLog.Top = frmDemo.Top
frmLog.Left = frmDemo.Left
frmLog.Show
' Get filename from registry
strLogFile = String(MAX_PATH, 0)
lngFileNameLen = Len(strLogFile)
If RegQueryValueEx(frmDemo.hKey, "Error Log Name", 0, _
                   lngData, ByVal strLogFile, _
                   lngFileNameLen) <> ERROR_SUCCESS Then
   lstLog.AddItem "< Log Unavailable >"
Else
   strLogFile = Left(strLogFile, lngFileNameLen)
   hFile = FreeFile()
   Open strLogFile For Input As #hFile
   Do While Not EOF(hFile)
      Line Input #hFile, strItem
      lngPos = InStr(1, strItem, "#")
      If lngPos > 0 Then
         lstLog.AddItem Left(strItem, lngPos - 1)
         lstLog.AddItem "   " & Trim(Mid(strItem, lngPos + 1))
      End If
   Loop
End If
Close #hFile
   
End Sub




