VERSION 5.00
Begin VB.Form frmDemo 
   Caption         =   "Error Message Demo"
   ClientHeight    =   4035
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   ClipControls    =   0   'False
   Icon            =   "VB Demo.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4035
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Image imgCover 
      BorderStyle     =   1  'Fixed Single
      Height          =   3810
      Left            =   810
      Picture         =   "VB Demo.frx":0442
      Stretch         =   -1  'True
      Top             =   75
      Width           =   2910
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&Information Message"
         Index           =   0
         Shortcut        =   ^I
      End
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&User Error"
         Index           =   1
         Shortcut        =   ^U
      End
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&Retry Error"
         Index           =   2
         Shortcut        =   ^R
      End
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&Non-Critical Error"
         Index           =   3
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&Severe Error"
         Index           =   4
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuViewMsg 
         Caption         =   "&Popup Message"
         Index           =   5
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuViewSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuViewLog 
         Caption         =   "&Error Log"
      End
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public hKey As Long

Private Function GetFileLen(ByVal strFileName As String) As Long

Dim lngSize As Long

On Error Resume Next
lngSize = FileLen(strFileName)
GetFileLen = lngSize

End Function


Private Sub Form_Load()

Dim lngKeyCreated As Long, lngResult As Long
Dim lngDataType As Long, lngValueLen As Long
Dim strRegPath As String
Dim strRegValueName As String, strRegValue As String

ChDir App.Path
' Get handle to registry key

strRegPath = "Software\OReilly\ErrorMsg"
strRegValueName = "Error Log Name"
strRegValue = String(MAX_PATH, 0)

' Open registry key
Call RegCreateKeyEx(HKEY_LOCAL_MACHINE, strRegPath, 0, 0, _
                    0, 0, 0, hKey, lngKeyCreated)
lngResult = RegQueryValueEx(hKey, strRegValueName, 0, _
            lngDataType, ByVal strRegValue, lngValueLen)
If lngKeyCreated = REG_CREATED_NEW_KEY Or lngResult <> ERROR_SUCCESS Then
   strRegValue = App.Path & "\VBErrorDemo.Log"
   Call RegSetValueEx(hKey, strRegValueName, 0, REG_SZ, _
        ByVal strRegValue, Len(strRegValue))
End If


End Sub

Private Sub Form_Unload(Cancel As Integer)

Call RegCloseKey(hKey)

End Sub


Private Sub mnuFileExit_Click()

Unload Me

End Sub


Private Sub mnuViewLog_Click()

frmDemo.Visible = False
Load frmLog

End Sub

Private Sub mnuViewMsg_Click(Index As Integer)

Dim lngDelay As Long
Dim strmsg As String, strCaptions As String, strTitle As String

Select Case Index
   ' Information message
   Case 0
      lngDelay = 10
      strTitle = "About the Cover"
      strCaptions = "The Animal:|What It Is:|Cover Credits:|"
      strmsg = "The animal featured on the cover of Developing "
      strmsg = strmsg & "Windows Error Messages is a basilisk.|"
      strmsg = strmsg & "Basilisks, members of the iguana family, are "
      strmsg = strmsg & "found from Southern Mexico to Ecuador. Adult "
      strmsg = strmsg & "male basilisks have distinctive casques on their "
      strmsg = strmsg & "heads and crests on their backs. Excellent "
      strmsg = strmsg & "swimmers and divers, basilisks occasionally hide "
      strmsg = strmsg & "on the bottom of bodies of water. Basilisks have "
      strmsg = strmsg & "the extraordinary ability to run across water. "
      strmsg = strmsg & "Using only their hind legs, and moving them extremely "
      strmsg = strmsg & "quickly, they slap the water, creating an air pocket "
      strmsg = strmsg & "below the surface, then lift their foot before the"
      strmsg = strmsg & "air pocket collapses. They can move across water "
      strmsg = strmsg & "surfaces at a rate of up to 12 kilometers per hour. "
      strmsg = strmsg & "Since this is faster than swimming, it affords them "
      strmsg = strmsg & "protection from hungry marine animals.|"
      strmsg = strmsg & "Edie Freedman designed the cover of this book, "
      strmsg = strmsg & "using a 19th-century engraving from the Dover "
      strmsg = strmsg & "Pictorial Archive. The cover layout was produced "
      strmsg = strmsg & "with Quark XPress 3.3 using the ITC Garamond font."
      Call ReportStdError(hKey, 0, Information, lngDelay, strmsg, _
                          strCaptions, strTitle)
   ' User error
   Case 1
      Dim strState
      
      strState = "NY"
      strTitle = "Invalid State Code"
      strCaptions = "The Error:||How to Correct It:|"
      strmsg = "The state code that you entered, " & strState
      strmsg = strmsg & ", is invalid.|"
      strmsg = strmsg & "You can try typing in a valid state "
      strmsg = strmsg & "code, or you can select a valid state "
      strmsg = strmsg & "from the drop-down list."
      Call ReportStdError(hKey, 122, USER_ERROR, 0, strmsg, _
                          strCaptions, strTitle)
   ' Retry error
   Case 2
      Dim lngFileSize As Long
      Dim strFN As String
      strFN = App.Path & "\MyFile.Txt"
      lngDelay = 30
      strTitle = "File Error"
      strCaptions = "The Problem:||What You Can Do About It:|"
      strmsg = "The program is unable to report the length of file " & strFN & ".|"
      strmsg = strmsg & "Use NotePad to create the file, or use Explorer to copy "
      strmsg = strmsg & "and rename another file. Make sure that the file is stored "
      strmsg = strmsg & "in the " & App.Path & " directory." & vbCrLf & vbCrLf
      strmsg = strmsg & "If you don't want file information, press Cancel." & vbCrLf & vbCrLf
      strmsg = strmsg & "Otherwise, press Retry Now, or wait until the program "
      strmsg = strmsg & "automatically tries to read the file again."
      Do While True
         lngFileSize = GetFileLen(strFN)
         If (lngFileSize > 0) Or _
            (ReportStdError(hKey, 0, RETRY_ERROR, lngDelay, _
                   strmsg, strCaptions, strTitle) = _
                   RESULT_CANCEL) Then
            Exit Sub
         End If
      Loop
   ' Non-critical error
   Case 3
      strTitle = ""        ' Use default title and captions
      strCaptions = ""
      strmsg = "Drive C: is running low on disk space.|"
      strmsg = strmsg & "If there is too little disk space available, it "
      strmsg = strmsg & "is possible that you won't be able to save "
      strmsg = strmsg & "new documents or your most recent changes to "
      strmsg = strmsg & "existing documents. Your system will also "
      strmsg = strmsg & "slow down.|"
      strmsg = strmsg & "You might try doing the following:" & vbCrLf
      strmsg = strmsg & "> Run ScanDisk to delete orphaned file clusters."
      strmsg = strmsg & vbCrLf
      strmsg = strmsg & "> Use Find to search for and delete all files with a .TMP extension."
      strmsg = strmsg & vbCrLf
      strmsg = strmsg & "> Use Find to search for and delete all files with a .BAK extension."
      strmsg = strmsg & vbCrLf
      strmsg = strmsg & "> Delete files that you know you don't need."
      Call ReportStdError(hKey, 145, NON_CRITICAL, 0, strmsg, _
                   strCaptions, strTitle)
   ' Severe error
   Case 4
      strCaptions = ""
      strTitle = ""
      strmsg = "The program was unable to write to Drive D:|"
      strmsg = strmsg & "Your file was not saved.|"
      strmsg = strmsg & "Your program's attempt to check for free disk space "
      strmsg = strmsg & "was unsuccessful. This tends to indicate a hardware "
      strmsg = strmsg & "problem with the disk itself. " & vbCrLf
      strmsg = strmsg & "To save your file, try saving to  a floppy disk or to "
      strmsg = strmsg & "another disk drive, if one is available on your system."
      strmsg = strmsg & vbCrLf & vbCrLf
      strmsg = strmsg & "To deal with your hard disk failure, we recommend that "
      strmsg = strmsg & "you consult a qualified technician."
      Call ReportStdError(hKey, 0, SEVERE_ERROR, 0, strmsg, _
                          strCaptions, strTitle)
    
   ' Popup message
   Case 5
      lngDelay = 3
      strmsg = "This is a fairly unobtrusive message that" & vbCrLf
      strmsg = strmsg & "will disappear after " & lngDelay & " seconds, unless" & vbCrLf
      strmsg = strmsg & "you click the mouse or press a key first."
      ReportPopup lngDelay, POPUP_TOP Or POPUP_LEFT, 100, 100, strmsg

End Select

End Sub


